##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (Heimdall)		= PkgName
# sampledir (ksm-heimdall	= pkg-dirname = pkg-filename (ksm-xxx)
# sampleconf (heimdall)		= config file name (no extension)
# sampledm (heimdalld)		= the daemon (rc-script, rc-link, systemd.service)
# sample (heimdall)		= all others
##############################################################################

# Specfile for Heimdall

%define name		ksm-heimdall
%define version		1.4.0
%define release		0.0.0
%define _arch		i386
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _sysddir	/etc/systemd/system
%define _uxbindir	/usr/bin
%define _uxsbindir	/usr/sbin
%define _bindir		/usr/local/bin
%define _sbindir	/usr/local/sbin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	Heimdall programs
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Other
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	heimdallpkg,heimdallcapab
Requires:	ksm-lib-sh >= 3.0.6-0.0.0
#Requires:	ksm-heimdall = %{version}-%{release}	# if lang pkg
#Provides:	heimdalld
#Conflicts:	heimdalld-other,libheimdall == 0.0.0
#Obsoletes:	myheimdalld

%description
This package contains programs for heimdall.
The package contains the following programs:

 heimdall, heimdall-frontend

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/heimdall.conf
#%config %{_confdir}/heimdall.conf
#%config %{_scnfdir}/heimdall
#%attr(644,root,root)%{_confdir}/heimdall.conf
#%attr(644,root,root)%{_scnfdir}/heimdall

#%attr(744,root,root)%{_rcdir}/heimdalld
#%attr(777,root,root)%{_sbindir}/rcheimdalld
#%attr(744,root,root)%{_sbindir}/heimdalld.sh

%attr(755,root,root)%{_bindir}/heimdall
%attr(755,root,root)%{_bindir}/heimdall-frontend

%{_datadir}/RELEASE
%{_datadir}/VERSION
#%attr(744,root,root)%{_datadir}/heimdalld.rc
#%{_datadir}/heimdalld.service

/usr/share/applications/Heimdall.desktop

#%{_icondir}/16x16/apps/heimdall.png
#%{_icondir}/22x22/apps/heimdall.png
#%{_icondir}/32x32/apps/heimdall.png
#%{_icondir}/48x48/apps/heimdall.png
#%{_icondir}/64x64/apps/heimdall.png
#%{_icondir}/128x128/apps/heimdall.png
#%{_icondir}/256x256/apps/heimdall.png
#%{_icondir}/512x512/apps/heimdall.png
#/usr/share/pixmaps/heimdall.png

%docdir %{_man1dir}
%{_man1dir}/heimdall.1.gz

%docdir %{_man8dir}
#%{_man8dir}/heimdalld.sh.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
%{_docdir}/README.de

#---------------------- ORDER OF SCRIPTLETS ----------------------------------
# O=old pkg, N=new pkg

# INSTALL:
# 1. Run %pre section of N		(Arg is 1)
# 2. Install files from N
# 3. Run %post section of N		(Arg is 1)

# UNINSTALL:
# 1. Run %preun section of O		(Arg is 0)
# 2. Delete files from O
# 3. Run %postun section of O		(Arg is 0)

# UPGRADE:
#  1. Run %pre section of O		(Arg is 2)
#  2. Install files from N
#  3. Run %post section of N		(Arg is 2)
#  4. Run installation triggers (%triggerin in other pkgs) set off by install N
#  5. Execute installation triggers of N
#  6. Run uninstallation triggers (%triggerun) of O
#  7. Run uninstallation triggers (of other pkgs) set off by uninstall O
#  8. Run %preun section of O		(Arg is 1)
#  9. Delete files not contained in N
# 10. Run %postun section of O		(Arg is 1)

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# create group and user
#ngroup='' nuser='' npwd='' ncomm='' nhomedir='' nlogsh='' ngid=0 nuid=0 ret=0

# backup config files
#test -e %{_confdir}/heimdall.conf && cp %{_confdir}/heimdall.conf %{_confdir}/heimdall.conf.rpmsave
#test -e %{_scnfdir}/heimdall && cp %{_scnfdir}/heimdall %{_scnfdir}/heimdall.rpmsave

# disable heimdall daemon and stop heimdalld
#test -x %{_bindir}/toggleheimdall && %{_bindir}/toggleheimdall -d -q > /dev/null 2>&1
#test -x %{_rcdir}/heimdalld && %{_rcdir}/heimdalld stop -q > /dev/null 2>&1

# rm links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
#rm -f %{_libdir}/libfuncstd-sh

# uninstall desktop files
#xdg-desktop-menu uninstall \
#	/usr/share/applications/heimdall.directory \
#	/usr/share/applications/heimdall.desktop \
#	/usr/share/applications/heimdall-admin.desktop

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# Definition of vars
# set config pathname and all config vars from new config file
#cf=%{_confdir}/heimdall.conf
#cnfvars='MyVar1 MyVar2'
#c='' s='' t=''
#
# update array vars
#cnt=0 i=0
#
# vars for update all users conf
#rcfile='' updcmd='' usr='' u=''
#
#ret=0

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"

# enable heimdall daemon
#test -x %{_bindir}/toggleheimdall && %{_bindir}/toggleheimdall -e -q > /dev/null 2>&1

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog
#ln -sf %{_libdir}/libfuncstd-sh-%{version} %{_libdir}/libfuncstd-sh

# install desktop files
#xdg-desktop-menu install --novendor \
#	/usr/share/applications/heimdall.directory \
#	/usr/share/applications/heimdall.desktop \
#	/usr/share/applications/heimdall-admin.desktop

# add a (new) template to heimdall
#f=/.../heimdall					# pathname of file
#templ=%{_datadir}/heimdall.add				# template in datadir
#tmpf=/tmp/heimdall					# tempfile
#flag=ksm-heimdall					# flag for entries
#if [ -e $f ]; then					# file exist
#	grep -q $flag $f				# look for flag
#	ret=$?
#	if [ $ret -ne 0 ]; then				# no flag found
#		cat $templ >> $f			# add entries
#	else						# flag found
#		cat $f | grep $flag > $tmpf		# get add from file
#		cmp -s $tmpf $templ			# cmp add vs. templ
#		ret=$?
#		if [ $ret -ne 0 ]; then			# templ is new
#			cat $f | grep -v $flag > $tmpf	# rm add from file
#			cp $tmpf $f
#			cat $templ >> $f		# add new entries
#		fi
#		rm -f $tmpf
#	fi
#else
#	echo "File $f not found!"
#fi

#if [ "$1" == 1 ]; then					# install package
#	echo "Configure $cf"
#	echo "Users must create HOME/.heimdallrc with update-heimdall"
#else							# upgrade package
#	# update global conf
#	if [ -e $cf.rpmsave ]; then
#		#cp $cf $cf.rpmnew
#		. $cf
#		. $cf.rpmsave
#
#		# update conf vars START -------------------------------------
#		if [ -x %{_bindir}/replcnfvar ]; then
#			for c in $cnfvars; do
#				t="\$$c"
#				eval s="$t"
#				s=\"$s\"
#				%{_bindir}/replcnfvar $cf $c "$s"
#			done
#		else
#			echo "Error - cmd replcnfvar not found or not executable!" >&2
#			echo "Conf file not updated!" >&2
#		fi
#		# update conf vars STOP --------------------------------------
#
#		# update array vars START ------------------------------------
#		# array var MainArr
#		cnt=${#MainArr[@]}			# max index of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any arrays in use?
#			while [ "$i" -lt $cnt ]; do
#				let i++
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi
#		# update array vars STOP -------------------------------------
#
#		# compare new conf vars <--> old conf vars
#		diff $cf $cf.rpmsave > /dev/null 2>&1
#		ret=$?
#		if [ "$ret" -eq 0 ]; then
#			rm $cf.rpmsave
#		else
#			echo "Check $cf"
#		fi
#	fi
#
#	# update all users conf START ----------------------------------------
#	rcfile='.heimdallrc'
#	updcmd="%{_bindir}/update-heimdall -q"
#	usr=`/usr/bin/grep /home/ /etc/passwd | /usr/bin/cut -d : -f 1`
#	for u in "$usr"; do
#		if [ -e /home/$u/$rcfile ]; then
#			/bin/su $u -c "$updcmd"
#		fi
#	done
#	if [ -e /root/$rcfile ]; then
#		$updcmd
#	fi
#	# update all users conf STOP -----------------------------------------
#
#	echo "If new version then users must update HOME/.heimdallrc with update-heimdall"
#fi
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

#if [ "$1" == 0 ]; then					# remove package
	# backup config files
	#test -e %{_confdir}/heimdall.conf && cp %{_confdir}/heimdall.conf %{_confdir}/heimdall.conf.rpmsave
	#test -e %{_scnfdir}/heimdall && cp %{_scnfdir}/heimdall %{_scnfdir}/heimdall.rpmsave

	# disable heimdall daemon and stop heimdalld
	#test -x %{_bindir}/toggleheimdall && %{_bindir}/toggleheimdall -d -q > /dev/null 2>&1
	#test -x %{_rcdir}/heimdalld && %{_rcdir}/heimdalld stop -q > /dev/null 2>&1

	# rm links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
	#rm -f %{_libdir}/libfuncstd-sh

	# uninstall desktop files
	#xdg-desktop-menu uninstall \
	#	/usr/share/applications/heimdall.directory \
	#	/usr/share/applications/heimdall.desktop \
	#	/usr/share/applications/heimdall-admin.desktop

	# remove entries from file heimdall
	#f=/.../heimdall				# pathname of file
	#tmpf=/tmp/heimdall				# tempfile
	#flag=ksm-heimdall				# flag for entries
	#ret=0
	#if [ -e $f ]; then
	#	grep -q $flag $f			# look for flag
	#	ret=$?
	#	if [ $ret -eq 0 ]; then			# flag found
	#		cat $f | grep -v $flag > $tmpf	# rm add from file
	#		cp $tmpf $f
	#		rm -f $tmpf
	#	fi
	#else
	#	echo "File $f not found!"
	#fi
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

# update icon cache
#gtk-update-icon-cache "/usr/share/icons/hicolor/"

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/ksm-heimdall
#else							# upgrade package
fi
exit 0

%changelog
* Wed Dec 23 2020 Repomaster <repomaster@kaesmann-online.de> 1.4.0-0.0.0
- The package has been revised/improved.

* Wed Dec 23 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.0-0.0.0
- This is the 1. version.
- The package contains following commands:
  heimdall
  heimdall-frontend
